;This program compute the factorial of a number loaded into AX
.model small
.stack 200h

.code
;main procedure
main proc
	mov  ax,8		; calculate 8! (try change this number and check if this program does factorial)
	push ax			; first put 8 into stack (pass parameter to subroutine)
	call Factorial	; call subroutine and return value in AX
	mov ax,4C00h	; exit to DOS
	int 21h
main endp

;Factorial procedure (subroutine)
Factorial proc
	push bp			; save register BP (as it will be changed in this procedure)
	mov  bp,sp		; BP=SP, from now on BP is used as pointer to access data in the stack (without changing SP)
	mov  ax,[bp+4]  ; get n,	note the parameter was passed to stack before calling Factorial
					; 			when calling Factorial, the return address pushed to stack (SP moves 2 byte)
					;			hence parameter is now at SP+2 (stack grows toward low addresses)
					;			first instruction in Factorial pushes BP into stack (SP moves 2 byte again)
					;			hence parameter is now at SP+2+2=SP+4
					;			therefore, the parameter is accessed by BP+4
	cmp  ax,1       ; n <= 1?,	this is important terminal decision for recursion - it decide when we stop calling
					;			Factorial again, i.e. so that we come out of the recursive calls when we reaches 1
					;			(no further multiplication needed)
	ja   L1         ; no: continue
					;			if AX > 1 (not reach 1 yet), we continue to multiply by n-1 (call Factorial again)
	mov  ax,1       ; yes: return 1
					;			if AX = 1, we exit the recursion and start doing the multiplication from 1,2,..,n
					;			(at point ## below)
	jmp  L2			; exit recursion (go up the level of recursion)

L1:	dec  ax			; n-1
	push ax         ; Factorial(n-1)
	call Factorial
	mov  bx,[bp+4]  ; get n (depends on which level of recursion we are at)
					; this is point ##, where we calculate 1x2, then x3, then x4, ... 
					; lastly	...
	mul  bx         ; 			... AX = AX * BX = (result of 1*2*...*n-1) * n
L2:	pop  bp			; restore register BP
	ret  2          ; AX = result, return and remove 2 bytes (the parameters) from stack
Factorial endp

end